#ifndef DHT11_H
#define	DHT11_H
//------------------------------------------------------------------------------
#include "../../assets/oneWire/oneWire.h"
//------------------------------------------------------------------------------
struct TempSensor
{
    unsigned char T_Byte1, T_Byte2, RH_Byte1, RH_Byte2, CheckSum;
};
//------------------------------------------------------------------------------
void dht11_init(void)
{
    oneWire_init();
}
//------------------------------------------------------------------------------
__bit dht11_getData(struct TempSensor *dht11)
{
    __bit static response = 0; 
    
    if(oneWire_readByte(&dht11->RH_Byte1) || oneWire_readByte(&dht11->RH_Byte2) || oneWire_readByte(&dht11->T_Byte1) || oneWire_readByte(&dht11->T_Byte2) || oneWire_readByte(&dht11->CheckSum))
    {
        response = 1;
    }
    
    return response;
}
//------------------------------------------------------------------------------
__bit dht11_isChecksumValid(struct TempSensor dht11)
{
    __bit static response = 0; 
    
    if(dht11.CheckSum == ((dht11.RH_Byte1 + dht11.RH_Byte2 + dht11.T_Byte1 + dht11.T_Byte2) & 0xFF))
    {
        response = 1;
    }
    
    return response;
}
//------------------------------------------------------------------------------
int dht11_getTemperature(struct TempSensor dht11)
{
    int tempr = (dht11.T_Byte2 << 8) + dht11.T_Byte1;
    
    return tempr;
}
//------------------------------------------------------------------------------
int dht11_getHumidity(struct TempSensor dht11)
{
    int humidity = (dht11.RH_Byte2 << 8) + dht11.RH_Byte1;
    
    return humidity;
}
//------------------------------------------------------------------------------
#endif	/* DHT11_H */