/* 
 * File:   main.c
 * Author: Bugz Bensce
 *
 * Created on 18 March 2023, 3:51 PM
 */

#define _XTAL_FREQ 8000000
#include <stdio.h>
#include <stdlib.h>
#include <xc.h>
//------------------------------------------------------------------------------
#include "assets/lcd/Lcd4.h"
#include "assets/DHT11/DHT11.h"
//------------------------------------------------------------------------------
int main(int argc, char** argv) 
{  
  OSCCON =  0x70;       // set internal oscillator to 8MHz
  ANSELH = 0;           // configure all PORTB pins as digital
  
  dht11_init();
  LCD_init();
  
  while(1)
  {
    oneWire_startSignal();
    struct TempSensor data;
     
    if(oneWire_checkResponse() && !dht11_getData(&data) && dht11_isChecksumValid(data))
    { 
        char strTempr[15];
        char strHumd[15];

        sprintf(strHumd,"Humidity: %2u%c", dht11_getHumidity(data), '%');
        sprintf(strTempr,"Temp: %2u%cC", dht11_getTemperature(data), 223);

        LCD_string(0,0, strHumd);
        LCD_string(1,0, strTempr);
    }
  }
  
  return (EXIT_SUCCESS);
}
//------------------------------------------------------------------------------